﻿using Connected.Annotations;
using Connected.ServiceModel;
using System.Collections.Immutable;

namespace Connected.Security.Permissions;

[Service]
[ServiceUrl(SecurityRoutes.Permissions)]
public interface IPermissionService
{
	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<ImmutableList<IPermission>?> Query();


	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<ImmutableList<IPermission>?> Query(PermissionSearchArgs args);


	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<IPermission?> Select(PrimaryKeyArgs<int> args);


	[ServiceMethod(ServiceMethodVerbs.Post)]
	Task<int> Insert(PermissionArgs args);


	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Patch)]
	Task Update(PermissionUpdateArgs args);


	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Delete)]
	Task Delete(PrimaryKeyArgs<int> args);
}
